<script setup>
    const config = useRuntimeConfig()

    import { holder_manager } from '../../adapters/holder_manager.js';
    import { ExistingHolder } from '../../adapters/holder.js';
    import { useClickOutsideEventListener } from '~/composables/graphics.js';

    // Data fetching
    const { data: organizers, pending } = await useFetch(`${config.public.apiUrl}/organizers`);

    const emit = defineEmits(["close"]);
    
    const tailleElement=30;

    onMounted(() => {
        useClickOutsideEventListener("form_organizers", () => {emit("close", true)});
    });

    function registerOrganizer(organizer) {
        holder_manager.register(new ExistingHolder(true, false, organizer.name, organizer.uid));
        // emit('close', true);
    }

    function removeOrganizer(organizer) {
        holder_manager.removeByObject(new ExistingHolder(true, false, organizer.name, organizer.uid));
    }
</script>

<template>
    <div class="w-full flex flex-col space-y-2 bg-white z-10">
        <!-- Organizers search list -->
        <FormSearchList
            :list=organizers 
            :tailleElement="tailleElement"
            :selected=holder_manager.getOrganizerNameList() 
            @add="(element) => registerOrganizer(element)" 
            @remove="(element) => removeOrganizer(element)"
        />
        <!-- Add new organizer -->
        <div class="flex flex-col py-4 space-y-2 text-center">
            <span class="text-center">Tu ne trouves pas ton organisateur ?</span>
            <ButtonLink :link-text="'Ajouter organisateur'" url="/holder?type=organizer"/>
        </div>
    </div>
</template>